package org.genealogie.web.tests;

import servletunit.struts.MockStrutsTestCase;

import org.genealogie.metier.modele.Auth;
import org.genealogie.utils.DatabaseUtils;
import org.genealogie.utils.JdbcConnectionSelector;

public class TestAccueilAction extends MockStrutsTestCase {

	public TestAccueilAction(String pName) {
		super(pName);
	}
	
	protected void setUp() throws Exception {
		super.setUp();
		Object[] params = new Object[4];
		params[0] = "org.hsqldb.jdbcDriver";
		params[1] = "jdbc:hsqldb:C:\\Eclipse\\workspace\\jgenea-refactoring\\db\\jgenea";
		params[2] = "sa";
		params[3] = "";
		JdbcConnectionSelector.getInstance().setStrategy(JdbcConnectionSelector.JDBC_DIRECT,params);
	}

	public void testSuccessfulLogin() {
		Auth auth = new Auth(1,"admin","admin",true,true,0,null,null,null,null,null);
		getSession().setAttribute("auth",auth);
		DatabaseUtils.setIdPool("Perso");
		setRequestPathInfo("/accueil");
		actionPerform();
		verifyForward("success");
		verifyForwardPath("/jsp/accueil.jsp");
		verifyNoActionErrors();
		assertNotNull(getRequest().getAttribute("nb"));
		assertNotNull(getRequest().getAttribute("nb-actes"));
		assertNotNull(getRequest().getAttribute("nb-documents"));
	}
}

