package org.genealogie.web.tests;

import org.genealogie.metier.modele.Auth;
import org.genealogie.utils.DatabaseUtils;
import org.genealogie.utils.JdbcConnectionSelector;
import org.genealogie.web.RechercherPersonnesChronologiqueForm;

import servletunit.struts.MockStrutsTestCase;

public class TestRechercherPersonneChronologiqueAction extends
		MockStrutsTestCase {
		
	public TestRechercherPersonneChronologiqueAction(String pName) {
		super(pName);
	}
	
	protected void setUp() throws Exception {
		super.setUp();
		Object[] params = new Object[4];
		params[0] = "org.hsqldb.jdbcDriver";
		params[1] = "jdbc:hsqldb:C:\\Eclipse\\workspace\\jgenea-refactoring\\db\\jgenea";
		params[2] = "sa";
		params[3] = "";
		JdbcConnectionSelector.getInstance().setStrategy(JdbcConnectionSelector.JDBC_DIRECT,params);
	}
	
	public void testSuccessfulLogin() {
		Auth auth = new Auth(1,"admin","admin",true,true,0,null,null,null,null,null);
		getSession().setAttribute("auth",auth);
		DatabaseUtils.setIdPool("Perso");
		setRequestPathInfo("/rechercherPersonnesChronologique");
		RechercherPersonnesChronologiqueForm form = new RechercherPersonnesChronologiqueForm();
		form.setAction("Create");
		form.setNom("");
		form.setPrenom("");
		form.setDateDebut("");
		form.setDateFin("");
		form.setVille("");
		form.setPage("");
		form.setNaissance("");
		form.setBapteme("");
		form.setMariage("");
		form.setDeces("");
		form.setInhumation("");
		setActionForm(form);
		actionPerform();
		verifyForward("success");
		verifyForwardPath("/jsp/liste_personnes.jsp");
		verifyNoActionErrors();
		assertNotNull(getRequest().getAttribute("result"));
	}
}
